<template>
  <div>
    <div class="global-error" v-if="globalError">
      {{ globalError }}
    </div>
    <form @submit.prevent="handleSubmit">
      <div class="form-row">
        <FormInput
            v-model="form.username"
            class="col"
            v-bind="getFieldProps('username', 'Username:')"
            @blur="validateField"
        />
      </div>
      <div class="form-actions">
        <button type="submit" class="submit-button" :disabled="disableSubmit">Register</button>
      </div>
    </form>
  </div>
</template>

<script>
import FormInput from "@/presentation/components/FormInput";
import { mapActions } from "vuex";

export default {
  name: 'CollaboratorRegisterForm',
  components: {
    FormInput
  },
  data() {
    return {
      form: {
        username: ''
      },
      validationErrors: this.getEmptyValidationErrors(),
      pristine: true,
      errorsCount: 0,
      globalError: ''
    }
  },
  computed: {
    disableSubmit: function () {
      return this.pristine || this.errorsCount > 0 || this.globalError !== '';
    }
  },
  methods: {
    ...mapActions([
      'registerCollaborator',
    ]),
    /**
     * Gets an object with the necessary form fields
     *
     * @param {string} id
     * @param {string} label
     * @return {object}
     */
    getFieldProps(id, label) {
      return {
        id,
        label,
        errorMessage: this.validationErrors[id],
      };
    },
    async handleSubmit() {
      try {
        await this.registerCollaborator(this.form);
      } catch (e) {
        if (e.violations) {
          e.violations.forEach((violation) => {
            this.validationErrors[violation.propertyPath] = violation.message;
            this.errorsCount++;
          });

          return;
        }

        this.globalError = 'Unknown error ...';

        return;
      }
      this.errorsCount = 0;
      this.pristine = true;
      this.form.username = '';
      this.globalError = '';
    },
    validateField(event) {
      this.pristine = false;
      this.globalError = '';
      const validationMessages = {
        username: 'Please, enter a username!',
      };

      const validationField = event.target.id;

      if (!this.form[validationField]) {
        this.validationErrors[validationField] = validationMessages[validationField];
        this.errorsCount++;
      } else {
        this.validationErrors[validationField] = null;
        this.errorsCount--;
      }
    },
    getEmptyValidationErrors() {
      return {
        username: null,
      };
    },
  }
}
</script>

<style scoped>
.form-row {
  margin-bottom: 1rem;
}

.form-row label {
  margin-right: 1rem;
}

.submit-button {
  border: 1px solid #055f05;
  padding: .3rem 1rem;
  color: #fff;
  background-color: #18a318;
}

.submit-button:hover {
  background-color: #57d457;
}

.submit-button:disabled {
  background-color: #57d457;
  color: #18a318;
}

.form-row.error input {
  border: 1px solid red;
}

.invalid-feedback {
  display: block;
  color: red;
  font-size: 1rem;
}

.global-error {
  background-color: red;
  color: white;
  padding: 1rem 2rem;
  margin-bottom: 1rem;
}

</style>
